------------------------------------------------------------------------
--logical Box motion generator "boxDancer"
--"produced by apras();"
--"http://www.apras.net/"
--
--memo
--摜}bvɁA{bNX𐶐Aj[V܂
--
------------------------------------------------------------------------
--
--
--N
------------------------------------------------------------------------
try
(
	gc light:true
	cui.UnRegisterDialogBar boxDancer 
	destroyDialog boxDancer 
)
catch
(
)
--
--
--ϐ
------------------------------------------------------------------------
xBox = 6
yBox = 6
boxMargin = 0
boxProp = undefined
boxArray = #()
dotImage = undefined
origBitMap = undefined
dotBitMap = undefined
keyFlag = false
nFrames = undefined

--
--
------------------------------------------------------------------------
fn boxMaker =
(
	local totalNum = yBox * xBox
	local currentNum = 0
	--
	progressStart "VoxelBox generating..."
	for i = 1 to yBox do
	(
		local pixel_line = getpixels dotBitMap [0,i-1] xBox
		local rowArray = #()
		
		for j = 1 to xBox do
		(
			local myBox = box()
			myBox.name = uniquename "VoxelBox"
			myBox.width = 20
			myBox.length = 20
			myBox.height = 20
			--
			if ((findItem boxProp 1) != 0) then
			(
				myBox.height = pixel_line[j].value/2
			)
			--
			if ((findItem boxProp 2) != 0) then
			(
				myBox.pos.z = pixel_line[j].value/2

			)
			
			myBox.wirecolor = pixel_line[j]
			myBox.pos.x = -(xBox*(20+boxMargin)/2)+(20+boxMargin)*(j-1)+(10+boxMargin/2)
			myBox.pos.y = ((20+boxMargin)*(-i)+(10+boxMargin/2))+(yBox*(20+boxMargin)/2)
			--
			append rowArray myBox
			currentNum += 1
			--
			if (getProgressCancel()) then
			(
				break;
			)else
			(
				progressUpdate (100.0 * currentNum / totalNum)
			)
			
		)
		append boxArray rowArray
	)
	progressEnd()
)
------------------------------------------------------------------------
--
--
------------------------------------------------------------------------
fn dotMaker =
(
	if (origBitMap != undefined) then
	(
		dotBitMap = bitmap xBox yBox
		copy origBitMap dotBitMap
		--display dotBitMap
		--
		return true
	)else
	(
		return false
	)
)
------------------------------------------------------------------------
--
--
------------------------------------------------------------------------
fn dancingSys =
(
	if (boxArray.count != 0) then
	(
		for i = 1 to yBox do
		(
			local pixel_line = getpixels dotBitMap [0,i-1] xBox
			for j = 1 to xBox do
			(
				--boxArray[i][j].height = pixel_line[j].value/2
				if ((findItem boxProp 1) != 0) then
				(
					boxArray[i][j].height = pixel_line[j].value/2
				)
				--
				if ((findItem boxProp 2) != 0) then
				(
					boxArray[i][j].pos.z = pixel_line[j].value/2
				)
				--
				boxArray[i][j].wirecolor = pixel_line[j]
			)
		)
	)
)
------------------------------------------------------------------------
--
--
------------------------------------------------------------------------
fn keySetter =
(
	progressStart "set keys ..."
	
	for cFrame = 1 to nFrames do
	(
		origBitMap.frame = (cFrame - 1)
		dotMaker()
		at time cFrame
		(
			for i = 1 to yBox do
			(
				local pixel_line = getpixels dotBitMap [0,i-1] xBox
				for j = 1 to xBox do
				(
					if ((findItem boxProp 1) != 0) then
					(
						animate on
						(
							boxArray[i][j].height = pixel_line[j].value/2
						)
					)
					--
					if ((findItem boxProp 2) != 0) then
					(
						animate on
						(
							boxArray[i][j].pos.z = pixel_line[j].value/2
						)
					)
				)
			)
		)
		if (getProgressCancel()) then
		(
			break;
		)else
		(
			progressUpdate (100.0 * cFrame / nFrames)
		)
	)
	progressEnd()
)
------------------------------------------------------------------------
--
--
------------------------------------------------------------------------
fn keyErase =
(
	
	for i = 1 to yBox do
	(
		for j = 1 to xBox do
		(
			if ((findItem boxProp 1) != 0) then
			(
				boxArray[i][j].height = pixel_line[j].value/2
				deleteKeys boxArray[i][j].height.controller #allKeys
			)
			--
			if ((findItem boxProp 2) != 0) then
			(
				--boxArray[i][j].pos.z = pixel_line[j].value/2
				deleteKeys boxArray[i][j].pos.controller #allKeys
			)
		)
	)
)
------------------------------------------------------------------------
--
--
------------------------------------------------------------------------

------------------------------------------------------------------------
--
--
------------------------------------------------------------------------
fn fileOpenDialog =
(
	bitImageFile = selectbitmap()
	dotMaker()
)
------------------------------------------------------------------------
rollout boxDancer "Box Dancer"
(

	--
	--
	local thumbnailBitMap = undefined
	--local nFrames = undefined
	--
	--
	spinner xNum "XLine" range:[0,96,xBox]@type:#integer scale:1 fieldwidth:80 pos:[15,10]
	spinner yNum "YLine" range:[0,96,yBox]@type:#integer scale:1 fieldwidth:80 pos:[15,30]
	spinner marginNum "margin" range:[0,30,0]@type:#integer scale:1 fieldwidth:80 pos:[9,50]
	label lb01 "--------------------"  pos:[10,70]
	MultiListBox boxPropList "" items:#("height","zPos") height:4 pos:[12,85]
	bitmap viewBitMap bitmap:(bitmap 90 90 color:gray) pos:[25,150]
	slider frameSli "" orient:#horizontal ticks:0 range:[0,100,0] type:#integer pos:[20,250]
	button mapSelBt "select map" width:120 pos:[10,280]
	button generateBt "generate" width:120 height:20 pos:[10,300]
	button eraseBt "erase" width:120 height:20 pos:[10,320]
	label lb02 "--------------------"  pos:[10,345]
	button setKey "set key" width:120 height:20 pos:[10,360]
	button eraseKey "erase key" width:120 height:20 pos:[10,380]
	label lb03 "--------------------"  pos:[10,405]
	label lb04 "\"Box Dancer v1.0\""  pos:[22,425]
	label lb05 "produced by apras();"  pos:[18,440]
	--
	--
	fn setMapFrame num =
	(
		local myFrames = nFrames * (num/100.0)
		myFrames = myFrames as Integer
		origBitMap.frame = myFrames
		dotMaker()
		copy origBitMap thumbnailBitMap
		viewBitMap.bitmap= thumbnailBitMap
		dancingSys()
	)
	--
	--
	on boxDancer open do
	(
		generateBt.enabled =false
		eraseBt.enabled = false
		frameSli.enabled = false
		setKey.enabled = false
		eraseKey.enabled = false
	)
	--
	--
	on generateBt pressed do
	(
		if (dotMaker()) then
		(
			if (boxProp != undefined) then
			(
				boxMaker()
			)else
			(
				messageBox("don't choice property !")
			)
		)else
		(
			messageBox("don't select map !")
		)
	)
	--
	--
	on eraseBt pressed do
	(
		for item in boxArray do
		(
			delete item
		)
		boxArray = #()
	)
	--
	--
	on yNum changed num do
	(
		yBox = num
	)
	--
	--
	on xNum changed num do
	(
		xBox = num
	)
	--
	--
	on marginNum changed num do
	(
		boxMargin = num 
	)
	--
	--
	on boxPropList selected num do
	(
		boxProp = boxPropList.selection
		print boxProp as string
	)
	--
	--
	on mapSelBt pressed do
	(
		origBitMap = selectBitMap()
		if (origBitMap != undefined) then
		(
			thumbnailBitMap= bitmap 120 90
			copy origBitMap thumbnailBitMap
			viewBitMap.bitmap = thumbnailBitMap
			if (origBitMap.numframes > 1) then
			(
				if (frameSli.enabled) then
				(
					nFrames = origBitMap.numframes
					animationRange = interval animationRange.start (nFrames-1)
					--
					setMapFrame (frameSli.value)
				)else
				(
					nFrames = origBitMap.numframes
					frameSli.enabled = true
					animationRange = interval animationRange.start (nFrames-1)
				)
			)
			dotMaker()
			dancingSys()
			generateBt.enabled = true
			eraseBt.enabled = true
			setKey.enabled = true
			--eraseKey.enabled = true
			--
		)
	)
	--
	--
	on frameSli changed num do
	(
		if (not keyFlag) then
		(
			
			local myFrames = nFrames * (num/100.0)
			myFrames = myFrames as Integer
			origBitMap.frame = myFrames
			dotMaker()
			copy origBitMap thumbnailBitMap
			viewBitMap.bitmap= thumbnailBitMap
			dancingSys()
			
			--setMapFrame num
		)else
		(
			local myFrames = nFrames * (num/100.0)
			myFrames = myFrames as Integer
			origBitMap.frame = myFrames
			copy origBitMap thumbnailBitMap
			viewBitMap.bitmap= thumbnailBitMap
		)
	)
	--
	--
	on setKey pressed do
	(
		keySetter()
		keyFlag = true
		setKey.enabled = false
		eraseKey.enabled = true
	)
	--
	--
	on eraseKey pressed do
	(
		keyErase()
		keyFlag = false
		setKey.enabled = true
		eraseKey.enabled = false
	)
)
------------------------------------------------------------------------
createDialog boxDancer 140 480 --menu:rc_Main
cui.RegisterDialogBar boxDancer style:#(#cui_dock_left , #cui_floatable, #cui_handles) 